#!/usr/local/bin/awk -f
# traceroute [-I] [-q #] <target> | trst.awk [-v v=1]
{
	n++
	h = substr($0,1,4) + 0 ## 4文字目までを取り出す
	if (h < 1) hop[n] = hop[n-1]
	else       hop[n] = h
	if (v) printf("%d ", hop[n])
	ncol = split(substr($0,5),col)
	tname[n]="n/a"; tip[n]="n/a"; # 名前とIPは n/a(not applicable)にしておく
	min[n] = 50000; max[n] = 0;
	delete delay
	acm_delay=0
	for (i=1; i<=ncol; i++) {
		if (v) printf (" %s", col[i]);
		if (tname[n] == "n/a") {
			if (col[i] == "*") {
				loss[n]++
				tt[n]++;
			} else { # tnameが定義されていなくて、名前を読み取れたら
				tname[n] = col[i++] # 名前を記録
				tip[n] = col[i]     # IPを記録
			}
		} else if (col[i] ~ /[0-9]*\.[0-9]*/) {
			tt[n]++;
			acm_delay += col[i];
			delay[i] = col[i]
			if (col[i] < min[n]) min[n] = col[i]
			if (col[i] > max[n]) max[n] = col[i]
			i++; # skip "ms"
		} else {
			if (col[i] == "*") {
				loss[n]++
				tt[n]++;
			}
		}
	}
	if (tt[n] != loss[n]) { # not 100% loss
		avg[n] = acm_delay / (tt[n] - loss[n])
		s = 0
		for (i in delay) {
			s += (delay[i] - avg[n])*(delay[i] - avg[n])
		}
		stdev[n] = sqrt(s/(tt[n]-loss[n]))
	}
	if (v) printf ("\n")
}

END {
	if (v) print "\n//////////////////////////////\n////  Statistics Report   ////\n//////////////////////////////"
	for (i=1; i<=n; i++) {
		if (tt[i] != loss[i]) {
			printf("%3d %s %s loss(%d/%d)=%0.2f%% avg=%0.3f(ms) min=%0.3f(ms) max=%0.3f(ms) stdev=%0.3f(ms)\n",
				hop[i], tname[i], tip[i], loss[i], tt[i], 100*loss[i]/tt[i], avg[i], min[i], max[i], stdev[i]);
		} else {
			printf("%3d %s %s loss=100%%\n", hop[i], tname[i], tip[i]);
		}
	}
}
